module     p3_uubar_emepg_diagramsh2l0fr5
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 3_uubar_emepg/helicity2/diagramsl0fr5.f90
   ! generator: haggies (1.1)
   use p3_uubar_emepg_color, only: numcs
   use p3_uubar_emepg_config, only: ki
   implicit none

   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   complex(ki), dimension(numcs), parameter :: zero_col = 0.0_ki

   public :: amplitude

contains
   function     amplitude()
      use p3_uubar_emepg_model
      use p3_uubar_emepg_kinematics
      use p3_uubar_emepg_color
      use p3_uubar_emepg_config, only: debug_lo_diagrams, &
        & use_sorted_sum
      use p3_uubar_emepg_accu, only: sorted_sum
      use p3_uubar_emepg_util, only: inspect_lo_diagram
      implicit none
      complex(ki), dimension(numcs) :: amplitude
      complex(ki), dimension(4,numcs) :: diagrams
      integer :: i
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      real(ki) :: t5
      real(ki) :: t6
      diagrams(:,:) = (0.0_ki, 0.0_ki)
      t1 = es34+i_*mZ*wZ-mZ*mZ
      t5 = gUl*gel
      t2 = (es34-(es51+es12))*t1*spak2k5*sqrt2
      t3 = t5/t2*spbk5k4
      t6 = gUr*gel
      t2 = t6/t2*spbk5k4
      t4 = t2-t3
      diagrams(4, :) = (spak1k3*i_*(4.0_ki)*((t3-t2)*es34+t4*es12+t4*es51)*c1)
      diagrams(3, :) = (0.0_ki)
      t1 = t1*es51*spak2k5*sqrt2
      diagrams(2, :) = (spak1k3*spak1k2*i_*(4.0_ki)*(t6/t1*spbk4k2*spbk5k1-t5/t1&
      &*spbk4k2*spbk5k1)*c1)
      diagrams(1, :) = (0.0_ki)
      if (debug_lo_diagrams) then
         call inspect_lo_diagram(diagrams(1,:), 1, 2, 19)
         call inspect_lo_diagram(diagrams(2,:), 2, 2, 19)
         call inspect_lo_diagram(diagrams(3,:), 3, 2, 19)
         call inspect_lo_diagram(diagrams(4,:), 4, 2, 19)
      end if

      if (use_sorted_sum) then
         do i=1,numcs
            amplitude(i) = sorted_sum(diagrams(:,i))
         end do
      else
         do i=1,numcs
            amplitude(i) = sum(diagrams(:,i))
         end do
      end if
   end function     amplitude
end module p3_uubar_emepg_diagramsh2l0fr5
